package org.jeecg.modules.stm.bcs.handle.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.bcs.handle.service.IBcsHandleMethodService;
import org.jeecg.modules.stm.bcs.handle.entity.BcsHandleMethod;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;

/**
 * @Description: 处置方案步骤
 * @Author: jeecg-boot
 * @Date:   2025-09-25
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/bcs.handle/bcsHandleMethod")
@Slf4j
public class BcsHandleMethodController extends JeecgController<BcsHandleMethod, IBcsHandleMethodService> {
	@Autowired
	private IBcsHandleMethodService bcsHandleMethodService;
	
	/**
	 * 分页列表查询
	 *
	 * @param bcsHandleMethod
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "处置方案步骤-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<BcsHandleMethod>> queryPageList(BcsHandleMethod bcsHandleMethod,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BcsHandleMethod> queryWrapper = QueryGenerator.initQueryWrapper(bcsHandleMethod, req.getParameterMap());
		queryWrapper.orderByAsc("step");
		Page<BcsHandleMethod> page = new Page<BcsHandleMethod>(pageNo, pageSize);
		IPage<BcsHandleMethod> pageList = bcsHandleMethodService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param bcsHandleMethod
	 * @return
	 */
	@AutoLog(value = "处置方案步骤-添加")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_method:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BcsHandleMethod bcsHandleMethod) {
		bcsHandleMethodService.save(bcsHandleMethod);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param bcsHandleMethod
	 * @return
	 */
	@AutoLog(value = "处置方案步骤-编辑")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_method:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BcsHandleMethod bcsHandleMethod) {
		bcsHandleMethodService.updateById(bcsHandleMethod);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "处置方案步骤-通过id删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_method:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		bcsHandleMethodService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "处置方案步骤-批量删除")
	  
	//@RequiresPermissions("bcs.handle:bcs_handle_method:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.bcsHandleMethodService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "处置方案步骤-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<BcsHandleMethod> queryById(@RequestParam(name="id",required=true) String id) {
		BcsHandleMethod bcsHandleMethod = bcsHandleMethodService.getById(id);
		if(bcsHandleMethod==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(bcsHandleMethod);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param bcsHandleMethod
    */
	//@RequiresPermissions("bcs.handle:bcs_handle_method:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BcsHandleMethod bcsHandleMethod) {
        return super.exportXls(request, bcsHandleMethod, BcsHandleMethod.class, "处置方案步骤");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
	// @RequiresPermissions("bcs.handle:bcs_handle_method:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BcsHandleMethod.class);
    }

}
